<?php
// OneThird CMS
// coyright(c) team1/3 All Rights Reserved.
// http://onethird.net/

	require_once(dirname(__FILE__).'/../config.php');
	session_regenerate_id(true);
	require_once(dirname(__FILE__).'/../module/utility.basic.php');

	basic_initialize();
	avoid_attack();
	snippet_avoid_robots();

	$params['manager'] = true;
	$params['template'] = 'admin.tpl';
	
	if (isset($_GET['circle'])) {
		$p_circle=sanitize_asc($_GET['circle']);
	} else {
		$p_circle=0;
	}

	if (!check_rights()) {
		exit_proc(403);
	}

	if (!check_rights('admin') && !isset($params['circle']['meta']['allow_upload'])) {
		exit_proc(403);
	}

	// プラグイン
	$plugin = $config['site_path'].'/plugin/plugin.php';
	if ( is_file($plugin) ) {
		require_once( $plugin );
	}
	$plugin = $config['files_path'].DIRECTORY_SEPARATOR.$p_circle.DIRECTORY_SEPARATOR.'plugin/plugin.php';
	if ( is_file($plugin) ) {
		require_once( $plugin );
	}

	$params['breadcrumb'][] = array( 'link'=>'', 'text'=>'File manager' );

	snippet_jqueryui();

	snippet_header();
	snippet_footer();
	snippet_system_nav();

	$html['article'][] = view();

	expand_circle_html();


function view()
{
	global $p_circle,$params,$config, $html;
	$buff = '';

	if (!isset($p_circle)) {
		return 'Invalid data';
	}
	if (!isset($_SESSION['login_id'])) {
		return ;
	}
	if (!isset($_GET['circle']) || (!check_rights('admin') && !isset($params['circle']['meta']['allow_upload']))) {
		exit('{"error":"Access error(E001)"}');
	}
	
	snippet_jqueryui();
$html['css'][] = <<<EOT
	<style>
		#elfinder * {
			-webkit-box-sizing: initial;
			-moz-box-sizing: initial;
			box-sizing: initial;
		}
	</style>
EOT;

$html['meta'][] = <<<EOT

	<!-- elFinder CSS (REQUIRED) -->
	<link rel="stylesheet" type="text/css" media="screen" href="{$config['site_url']}js/elfinder/css/elfinder.min.css">
	<link rel="stylesheet" type="text/css" media="screen" href="{$config['site_url']}js/elfinder/css/theme.css">

	<!-- elFinder JS (REQUIRED) -->
	<script type="text/javascript" src="{$config['site_url']}js/elfinder/elfinder.min.js"></script>

	<!-- elFinder translation (OPTIONAL) -->
	<script type="text/javascript" src="{$config['site_url']}js/elfinder/i18n/elfinder.jp.js"></script>
	
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.2.3/ace.js"></script>
	<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.2.3/ext-modelist.js"></script>
	
<script >  
opt = {
	edit : {
		mimes : []
		, editors : [
			{
				// `mimes` is not set for support everything kind of text file
				mimes : ['text/plain','text/x-php','text/html']
				, load : function(textarea) {
					var self = this;
					var editorBase, mode;
					var ta = \$(textarea);
					var taBase = ta.parent();
					var dialog = taBase.parent();
					dialog.css({position: "fixed",top: 0,left: 0,width: "100%",height: "100%","z-index":999999});
					var id = textarea.id + '_ace';
					var filename = dialog.find(".ui-dialog-titlebar").text();
					resize = function(){
						dialog.height(\$(window).height() * 0.9).trigger('posinit');
						taBase.height(dialog.height() - taBase.prev().outerHeight(true) - taBase.next().outerHeight(true) - 8);
					};

					mode = ace.require('ace/ext/modelist').getModeForPath('/' + filename).name;

					editorBase = \$('<div id="'+id+'" style="width:100%; height:100%;"/>').text(ta.val()).insertBefore(ta.hide());

					ta.data('ace', true);
					ot.ace_editor = ace.edit(id);
					ot.ace_editor.\$blockScrolling = Infinity;
					ot.ace_editor.setOptions({
						theme: 'ace/theme/monokai',
						mode: 'ace/mode/' + mode,
						wrap: true,
					});
					dialog.on('resize', function(){ ot.ace_editor.resize(); });
					\$(window).on('resize', function(e){
						if (e.target !== this) return;
						dialog.data('resizeTimer') && clearTimeout(dialog.data('resizeTimer'));
						dialog.data('resizeTimer', setTimeout(function(){ resize(); }, 300));
					});
					resize();
					ot.ace_editor.resize();
					return ot.ace_editor;
				},
				save : function(textarea) {
					if (\$(textarea).data('ace')) {
						\$(textarea).val(ot.ace_editor.session.getValue());
					}
				}
				,close  : function() {
					ot.elfinder.resize("auto");
				}
				,focus : function(textarea) {
					ot.ace_editor.focus();
				}
			}
		]
	}
};
\$(function() {  
	ot.elfinder = \$('#elfinder').elfinder({
		url : '{$config['site_url']}admin/elfinder/connector.php?circle=$p_circle'  // connector URL (REQUIRED)
		, lang: 'ja'		// language
		, commandsOptions : opt
	}).elfinder('instance');
	
}) ;

</script >  

EOT;

$buff .= <<<EOT
	<div id="elfinder" >
	</div>
EOT;


	return $buff;

}

?>